/*@@
  @header   BSCHR1_guts.h
  @date     Nov 98
  @author   Gabrielle Allen
  @desc
  Macro to calculate Christoffel symbols of the first kind 
  for the BS variables

  That is BSCHR1_cab = 1/2 (BSg_ac,b + BSgbc,a - BSgab,c)

  @enddesc
@@*/

#ifndef BSCHR1_GUTS
#define BSCHR1_GUTS

#include "macro/BSDG_guts.h"

#ifdef FCODE

      BSCHR1_XXX = BSDXDG_DXDGXX*0.5D0
      BSCHR1_XXY = BSDYDG_DYDGXX*0.5D0
      BSCHR1_XXZ = BSDZDG_DZDGXX*0.5D0
      BSCHR1_XYY = -BSDXDG_DXDGYY*0.5D0 + BSDYDG_DYDGXY
      BSCHR1_XYZ = (-BSDXDG_DXDGYZ + BSDYDG_DYDGXZ + BSDZDG_DZDGXY)*0.5D0
      BSCHR1_XZZ = -BSDXDG_DXDGZZ*0.5D0 + BSDZDG_DZDGXZ
      BSCHR1_YXX = BSDXDG_DXDGXY - BSDYDG_DYDGXX*0.5D0
      BSCHR1_YXY = BSDXDG_DXDGYY*0.5D0
      BSCHR1_YXZ = ( BSDXDG_DXDGYZ - BSDYDG_DYDGXZ + BSDZDG_DZDGXY)*0.5D0
      BSCHR1_YYY = BSDYDG_DYDGYY*0.5D0
      BSCHR1_YYZ = BSDZDG_DZDGYY*0.5D0
      BSCHR1_YZZ = -BSDYDG_DYDGZZ*0.5D0 + BSDZDG_DZDGYZ
      BSCHR1_ZXX =  BSDXDG_DXDGXZ - BSDZDG_DZDGXX*0.5D0
      BSCHR1_ZXY = ( BSDXDG_DXDGYZ + BSDYDG_DYDGXZ - BSDZDG_DZDGXY)*0.5D0
      BSCHR1_ZXZ = BSDXDG_DXDGZZ*0.5D0
      BSCHR1_ZYY = BSDYDG_DYDGYZ - BSDZDG_DZDGYY*0.5D0
      BSCHR1_ZYZ = BSDYDG_DYDGZZ*0.5D0
      BSCHR1_ZZZ = BSDZDG_DZDGZZ*0.5D0

#endif

#ifdef CCODE

      BSCHR1_XXX = BSDXDG_DXDGXX/2;
      BSCHR1_XXY = BSDYDG_DYDGXX/2;
      BSCHR1_XXZ = BSDZDG_DZDGXX/2;
      BSCHR1_XYY = -BSDXDG_DXDGYY/2 + BSDYDG_DYDGXY;
      BSCHR1_XYZ = (-BSDXDG_DXDGYZ + BSDYDG_DYDGXZ + BSDZDG_DZDGXY)/2;
      BSCHR1_XZZ = -BSDXDG_DXDGZZ/2 + BSDZDG_DZDGXZ;
      BSCHR1_YXX = BSDXDG_DXDGXY - BSDYDG_DYDGXX/2;
      BSCHR1_YXY = BSDXDG_DXDGYY/2;
      BSCHR1_YXZ = ( BSDXDG_DXDGYZ - BSDYDG_DYDGXZ + BSDZDG_DZDGXY)/2;
      BSCHR1_YYY = BSDYDG_DYDGYY/2;
      BSCHR1_YYZ = BSDZDG_DZDGYY/2;
      BSCHR1_YZZ = -BSDYDG_DYDGZZ/2 + BSDZDG_DZDGYZ;
      BSCHR1_ZXX =  BSDXDG_DXDGXZ - BSDZDG_DZDGXX/2;
      BSCHR1_ZXY = ( BSDXDG_DXDGYZ + BSDYDG_DYDGXZ - BSDZDG_DZDGXY)/2;
      BSCHR1_ZXZ = BSDXDG_DXDGZZ/2;
      BSCHR1_ZYY = BSDYDG_DYDGYZ - BSDZDG_DZDGYY/2;
      BSCHR1_ZYZ = BSDYDG_DYDGZZ/2;
      BSCHR1_ZZZ = BSDZDG_DZDGZZ/2;

#endif

#endif

